﻿Imports System.Management

Module Module1
    Sub Main()
        Dim strUser As String = ""
        Dim strPass As String = ""
        Dim objManagementScope As ManagementScope = ConnectManagementScope("win2008r2.local", strUser, strPass)
        'Call DefineVM(objManagementScope, "VM01", "D:\Hyper-V\VM01")
        'Call SetDynamicMemory(objManagementScope, "VM01", 1024)
        'Call SetProcessor(objManagementScope, "VM01", 2)
        'Call SetNetworkAdapter(objManagementScope, "VM01", "LAN")
        'Call SetIDEHardDisk(objManagementScope, "VM01", "D:\Hyper-V\VM01.vhd")
        'SetScsiController(objManagementScope, "VM01")
        'SetScsiHardDisk(objManagementScope, "VM01", "D:\Hyper-V\50GB.vhd")
        SetDVD(objManagementScope, "VM01")
        'MountISO(objManagementScope, "VM01", "D:\Hyper-V\demo.iso")
        'UnMountISO(objManagementScope, "VM01")
    End Sub

    Function ConnectManagementScope(ByVal strServer As String, ByVal strAccount As String, ByVal strPassword As String) As ManagementScope
        Dim objConnectionOptions As New ConnectionOptions()
        objConnectionOptions.Impersonation = ImpersonationLevel.Impersonate 'WMI への接続に使用される偽装レベルを設定
        objConnectionOptions.EnablePrivileges = True 'WNI経由の操作のためにユーザー特権を有効にする
        objConnectionOptions.Username = strAccount
        objConnectionOptions.Password = strPassword
        Dim objManagementScope As New ManagementScope("\\" + strServer + "\root\virtualization", objConnectionOptions)
        objManagementScope.Connect()
        Return (objManagementScope)
    End Function

    Function ConnectManagementScope() As ManagementScope
        Dim objManagementScope As New ManagementScope("\\.\root\virtualization")
        objManagementScope.Connect()
        Return (objManagementScope)
    End Function

    Sub GetVMList(ByVal objManagementScope As ManagementScope)
        Dim objObjectQuery As New ObjectQuery("SELECT * FROM Msvm_ComputerSystem WHERE Caption LIKE '仮想マシン'")
        Dim objManagementObjectSearcher As New ManagementObjectSearcher(objManagementScope, objObjectQuery)
        Dim objManagementObjectCollection As ManagementObjectCollection = objManagementObjectSearcher.Get
        For Each objManagementObject As ManagementObject In objManagementObjectCollection
            Console.WriteLine(objManagementObject("ElementName"))
        Next
    End Sub

    Function DefineVM(ByVal objManagementScope As ManagementScope, ByVal strVMName As String, ByVal strFolderPath As String) As Boolean
        Dim objVirtualSystemGlobalsettingData As New ManagementClass(objManagementScope, New ManagementPath("Msvm_VirtualSystemGlobalsettingData"), Nothing)
        Dim objVirtualSystemGlobalsettingDataInstance As ManagementObject = objVirtualSystemGlobalsettingData.CreateInstance
        objVirtualSystemGlobalsettingDataInstance("ElementName") = strVMName
        objVirtualSystemGlobalsettingDataInstance("ExternalDataRoot") = strFolderPath
        Dim strSystemsettingData As String = objVirtualSystemGlobalsettingDataInstance.GetText(TextFormat.CimDtd20)

        For Each objVirtualSystemManagementService As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemManagementService")).Get
            Dim objParams As ManagementBaseObject = objVirtualSystemManagementService.GetMethodParameters("DefineVirtualSystem")
            objParams("ResourceSettingData") = Nothing
            objParams("Sourcesetting") = Nothing
            objParams("SystemsettingData") = strSystemsettingData
            Dim objManagementBaseObject As ManagementBaseObject = objVirtualSystemManagementService.InvokeMethod("DefineVirtualSystem", objParams, Nothing)
            Return JobComplete(objManagementBaseObject, objManagementScope)
        Next
    End Function

    Function SetDynamicMemory(ByVal objManagementScope As ManagementScope, ByVal strVMName As String, ByVal intMemory As Integer) As Boolean
        Dim objComputerSystem As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ComputerSystem WHERE ElementName = '" & strVMName & "'")).Get
            objComputerSystem = objManagementObject
        Next

        Dim objVirtualSystemSettingData As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemSettingData WHERE ElementName = '" & strVMName & "'")).Get
            objVirtualSystemSettingData = objManagementObject
        Next

        Dim strMemorySettingData As String = ""
        Dim objMemorySettingDataCollection As ManagementObjectCollection = objVirtualSystemSettingData.GetRelated("Msvm_MemorySettingData")
        For Each objManagementObject As ManagementObject In objMemorySettingDataCollection
            objManagementObject("DynamicMemoryEnabled") = True
            objManagementObject("VirtualQuantity") = intMemory
            objManagementObject("Limit") = 4096
            objManagementObject("TargetMemoryBuffer") = 20
            objManagementObject("Weight") = 5000
            objManagementObject("Reservation") = intMemory
            strMemorySettingData = objManagementObject.GetText(TextFormat.CimDtd20)
        Next

        For Each objVirtualSystemManagementService As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemManagementService")).Get
            Dim objParams As ManagementBaseObject = objVirtualSystemManagementService.GetMethodParameters("ModifyVirtualSystemResources")
            objParams("ResourceSettingData") = New String() {strMemorySettingData}
            objParams("ComputerSystem") = objComputerSystem.Path.Path
            Dim objManagementBaseObject As ManagementBaseObject = objVirtualSystemManagementService.InvokeMethod("ModifyVirtualSystemResources", objParams, Nothing)
            Return JobComplete(objManagementBaseObject, objManagementScope)
        Next
    End Function

    Function SetStaticMemory(ByVal objManagementScope As ManagementScope, ByVal strVMName As String, ByVal intMemory As Integer) As Boolean
        Dim objComputerSystem As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ComputerSystem WHERE ElementName = '" & strVMName & "'")).Get
            objComputerSystem = objManagementObject
        Next

        Dim objVirtualSystemSettingData As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemSettingData WHERE ElementName = '" & strVMName & "'")).Get
            objVirtualSystemSettingData = objManagementObject
        Next

        Dim strMemorySettingData As String = ""
        Dim objMemorySettingDataCollection As ManagementObjectCollection = objVirtualSystemSettingData.GetRelated("Msvm_MemorySettingData")
        For Each objManagementObject As ManagementObject In objMemorySettingDataCollection
            objManagementObject("VirtualQuantity") = intMemory
            strMemorySettingData = objManagementObject.GetText(TextFormat.CimDtd20)
        Next

        For Each objVirtualSystemManagementService As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemManagementService")).Get
            Dim objParams As ManagementBaseObject = objVirtualSystemManagementService.GetMethodParameters("ModifyVirtualSystemResources")
            objParams("ResourceSettingData") = New String() {strMemorySettingData}
            objParams("ComputerSystem") = objComputerSystem.Path.Path
            Dim objManagementBaseObject As ManagementBaseObject = objVirtualSystemManagementService.InvokeMethod("ModifyVirtualSystemResources", objParams, Nothing)
            Return JobComplete(objManagementBaseObject, objManagementScope)
        Next
    End Function

    Function SetProcessor(ByVal objManagementScope As ManagementScope, ByVal strVMName As String, ByVal intProcessor As Integer) As Boolean
        Dim objComputerSystem As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ComputerSystem WHERE ElementName = '" & strVMName & "'")).Get
            objComputerSystem = objManagementObject
        Next

        Dim objVirtualSystemsettingData As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In objComputerSystem.GetRelated("Msvm_VirtualSystemsettingData")
            objVirtualSystemsettingData = objManagementObject
        Next

        Dim objProcessorSettingData As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In objVirtualSystemsettingData.GetRelated("Msvm_ProcessorSettingData")
            objProcessorSettingData = objManagementObject
            objProcessorSettingData("VirtualQuantity") = intProcessor
        Next

        For Each objVirtualSystemManagementService As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemManagementService")).Get
            Dim objParams As ManagementBaseObject = objVirtualSystemManagementService.GetMethodParameters("ModifyVirtualSystemResources")
            Dim strResourceSettingData As String() = New String(0) {}
            strResourceSettingData(0) = objProcessorSettingData.GetText(TextFormat.CimDtd20)
            objParams("ResourceSettingData") = strResourceSettingData
            objParams("ComputerSystem") = objComputerSystem.Path.Path
            Dim objManagementBaseObject As ManagementBaseObject = objVirtualSystemManagementService.InvokeMethod("ModifyVirtualSystemResources", objParams, Nothing)
            Return JobComplete(objManagementBaseObject, objManagementScope)
        Next
    End Function

    Function SetNetworkAdapter(ByVal objManagementScope As ManagementScope, ByVal strVMName As String, ByVal strNetworkName As String) As Boolean
        Dim objComputerSystem As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ComputerSystem WHERE ElementName = '" & strVMName & "'")).Get
            objComputerSystem = objManagementObject
        Next

        Dim objVirtualSwitchManagementService As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSwitchManagementService")).Get
            objVirtualSwitchManagementService = objManagementObject
        Next

        Dim objVirtualSwitch As ManagementObject = Nothing
        Dim objSwitchPort As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSwitch WHERE ElementName = '" & strNetworkName & "'")).Get
            objVirtualSwitch = objManagementObject
            Dim objParams As ManagementBaseObject = objVirtualSwitchManagementService.GetMethodParameters("CreateSwitchPort")
            objParams("Name") = DateTime.Now.ToString("yyymmddhhmmss")
            objParams("FriendlyName") = objParams("Name").ToString
            objParams("VirtualSwitch") = objVirtualSwitch.Path.Path
            Dim objManagementBaseObject As ManagementBaseObject = objVirtualSwitchManagementService.InvokeMethod("CreateSwitchPort", objParams, Nothing)
            objSwitchPort = New ManagementObject(objManagementScope, New ManagementPath(objManagementBaseObject("CreatedSwitchPort").ToString), Nothing)
        Next
      
        Dim objDefaultNic As ManagementObject = Nothing
        For Each objResourcePool As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ResourcePool WHERE ResourceType = 10 AND ResourceSubType = 'Microsoft Synthetic Ethernet Port' AND OtherResourceType = null")).Get
            Dim objAllocationCapabilitiesCollection As ManagementObjectCollection = objResourcePool.GetRelated("Msvm_AllocationCapabilities")
            For Each objAllocationCapabilities As ManagementObject In objAllocationCapabilitiesCollection
                Dim objSettingsDefineCapabilitiesCollection As ManagementObjectCollection = objAllocationCapabilities.GetRelationships("Msvm_SettingsDefineCapabilities")

                For Each objSettingsDefineCapabilities As ManagementObject In objSettingsDefineCapabilitiesCollection
                    If objSettingsDefineCapabilities("ValueRole") = 0 Then
                        objDefaultNic = New ManagementObject(objSettingsDefineCapabilities("PartComponent").ToString())
                        objDefaultNic.Scope = objManagementScope
                    End If
                Next
            Next
        Next
       
        For Each objVirtualSystemManagementService As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemManagementService")).Get
            Dim objParams As ManagementBaseObject = objVirtualSystemManagementService.GetMethodParameters("AddVirtualSystemResources")
            objDefaultNic("Connection") = New String() {objSwitchPort.Path.Path}
            objDefaultNic("StaticMacAddress") = False
            objDefaultNic("ElementName") = "ネットワーク アダプター"
            Dim strVirtualSystemIdentifiers As String() = New String(0) {}
            strVirtualSystemIdentifiers(0) = String.Format("{{{0}}}", Guid.NewGuid())
            objDefaultNic("VirtualSystemIdentifiers") = strVirtualSystemIdentifiers

            Dim strResourceSettingData As String() = New String(0) {}
            strResourceSettingData(0) = objDefaultNic.GetText(TextFormat.CimDtd20)
            objParams("ResourceSettingData") = strResourceSettingData
            objParams("TargetSystem") = objComputerSystem.Path.Path

            Dim objManagementBaseObject As ManagementBaseObject = objVirtualSystemManagementService.InvokeMethod("AddVirtualSystemResources", objParams, Nothing)
            Return JobComplete(objManagementBaseObject, objManagementScope)
        Next
    End Function

    Function SetIDEHardDisk(ByVal objManagementScope As ManagementScope, ByVal strVMName As String, ByVal strDiskPath As String) As Boolean
        Dim objComputerSystem As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ComputerSystem WHERE ElementName = '" & strVMName & "'")).Get
            objComputerSystem = objManagementObject
        Next

        Dim objDiskDrive As ManagementObject = Nothing
        For Each objResourcePool As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ResourcePool WHERE ResourceType = 22 AND ResourceSubType = 'Microsoft Synthetic Disk Drive' AND OtherResourceType = null")).Get
            Dim objAllocationCapabilitiesCollection As ManagementObjectCollection = objResourcePool.GetRelated("Msvm_AllocationCapabilities")
            For Each objAllocationCapabilities As ManagementObject In objAllocationCapabilitiesCollection
                Dim objSettingsDefineCapabilitiesCollection As ManagementObjectCollection = objAllocationCapabilities.GetRelationships("Msvm_SettingsDefineCapabilities")
                For Each objSettingsDefineCapabilities As ManagementObject In objSettingsDefineCapabilitiesCollection
                    If objSettingsDefineCapabilities("ValueRole") = 0 Then
                        objDiskDrive = New ManagementObject(objSettingsDefineCapabilities("PartComponent").ToString())
                        objDiskDrive.Scope = objManagementScope
                    End If
                Next
            Next
        Next

        Dim objIDEController As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ResourceAllocationSettingData WHERE ResourceType = 5 AND ResourceSubType = 'Microsoft Emulated IDE Controller' AND Address = '0'")).Get
            objIDEController = objManagementObject
            objDiskDrive("Parent") = objIDEController.Path.Path
            objDiskDrive("Address") = 0
        Next

        For Each objVirtualSystemManagementService As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemManagementService")).Get
            Dim objParams As ManagementBaseObject = objVirtualSystemManagementService.GetMethodParameters("AddVirtualSystemResources")
            Dim strResourceSettingData As String() = New String(0) {}
            strResourceSettingData(0) = objDiskDrive.GetText(TextFormat.CimDtd20)
            objParams("ResourceSettingData") = strResourceSettingData
            objParams("TargetSystem") = objComputerSystem.Path.Path
            Dim objManagementBaseObject As ManagementBaseObject = objVirtualSystemManagementService.InvokeMethod("AddVirtualSystemResources", objParams, Nothing)
        Next

        Dim objHardDisk As ManagementObject = Nothing
        For Each objResourcePool As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ResourcePool WHERE ResourceType = 21 AND ResourceSubType = 'Microsoft Virtual Hard Disk' AND OtherResourceType = null")).Get
            Dim objAllocationCapabilitiesCollection As ManagementObjectCollection = objResourcePool.GetRelated("Msvm_AllocationCapabilities")
            For Each objAllocationCapabilities As ManagementObject In objAllocationCapabilitiesCollection
                Dim objSettingsDefineCapabilitiesCollection As ManagementObjectCollection = objAllocationCapabilities.GetRelationships("Msvm_SettingsDefineCapabilities")
                For Each objSettingsDefineCapabilities As ManagementObject In objSettingsDefineCapabilitiesCollection
                    If objSettingsDefineCapabilities("ValueRole") = 0 Then
                        objHardDisk = New ManagementObject(objSettingsDefineCapabilities("PartComponent").ToString())
                        objHardDisk.Scope = objManagementScope
                    End If
                Next
            Next
        Next

        Dim objIDEDrive As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ResourceAllocationSettingData WHERE Parent = '" & objIDEController.Path.Path.Replace("\", "\\") & "' AND Address = '0'")).Get
            objIDEDrive = objManagementObject
            objHardDisk("Parent") = objIDEDrive.Path.Path
            objHardDisk("Connection") = New String(0) {strDiskPath}
        Next

        For Each objVirtualSystemManagementService As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemManagementService")).Get
            Dim objParams As ManagementBaseObject = objVirtualSystemManagementService.GetMethodParameters("AddVirtualSystemResources")
            Dim strResourceSettingData As String() = New String(0) {}
            strResourceSettingData(0) = objHardDisk.GetText(TextFormat.CimDtd20)
            objParams("ResourceSettingData") = strResourceSettingData
            objParams("TargetSystem") = objComputerSystem.Path.Path
            Dim objManagementBaseObject As ManagementBaseObject = objVirtualSystemManagementService.InvokeMethod("AddVirtualSystemResources", objParams, Nothing)
            Return JobComplete(objManagementBaseObject, objManagementScope)
        Next
    End Function

    Function SetScsiController(ByVal objManagementScope As ManagementScope, ByVal strVMName As String) As Boolean
        Dim objComputerSystem As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ComputerSystem WHERE ElementName = '" & strVMName & "'")).Get
            objComputerSystem = objManagementObject
        Next

        Dim objSCSIController As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ResourceAllocationSettingData WHERE ResourceType = 6 AND ResourceSubType = 'Microsoft Synthetic SCSI Controller' AND OtherResourceType = null")).Get
            objSCSIController = objManagementObject
            objSCSIController("ElementName") = "SCSI コントローラー"
        Next

        For Each objVirtualSystemManagementService As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemManagementService")).Get
            Dim objParams As ManagementBaseObject = objVirtualSystemManagementService.GetMethodParameters("AddVirtualSystemResources")
            Dim strResourceSettingData As String() = New String(0) {}
            strResourceSettingData(0) = objSCSIController.GetText(TextFormat.CimDtd20)
            objParams("ResourceSettingData") = strResourceSettingData
            objParams("TargetSystem") = objComputerSystem.Path.Path
            Dim objManagementBaseObject As ManagementBaseObject = objVirtualSystemManagementService.InvokeMethod("AddVirtualSystemResources", objParams, Nothing)
            Return JobComplete(objManagementBaseObject, objManagementScope)
        Next
    End Function

    Function SetScsiHardDisk(ByVal objManagementScope As ManagementScope, ByVal strVMName As String, ByVal strDiskPath As String) As Boolean
           Dim objComputerSystem As ManagementObject = Nothing
            For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ComputerSystem WHERE ElementName = '" & strVMName & "'")).Get
                objComputerSystem = objManagementObject
            Next

            Dim objDiskDrive As ManagementObject = Nothing
            For Each objResourcePool As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ResourcePool WHERE ResourceType = 22 AND ResourceSubType = 'Microsoft Synthetic Disk Drive' AND OtherResourceType = null")).Get
                Dim objAllocationCapabilitiesCollection As ManagementObjectCollection = objResourcePool.GetRelated("Msvm_AllocationCapabilities")
                For Each objAllocationCapabilities As ManagementObject In objAllocationCapabilitiesCollection
                    Dim objSettingsDefineCapabilitiesCollection As ManagementObjectCollection = objAllocationCapabilities.GetRelationships("Msvm_SettingsDefineCapabilities")
                    For Each objSettingsDefineCapabilities As ManagementObject In objSettingsDefineCapabilitiesCollection
                        If objSettingsDefineCapabilities("ValueRole") = 0 Then
                            objDiskDrive = New ManagementObject(objSettingsDefineCapabilities("PartComponent").ToString())
                            objDiskDrive.Scope = objManagementScope
                        End If
                    Next
                Next
            Next

            Dim objSCSIController As ManagementObject = Nothing
            For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ResourceAllocationSettingData WHERE ResourceType = 6 AND ResourceSubType = 'Microsoft Synthetic SCSI Controller' AND OtherResourceType = null")).Get
                objDiskDrive("Parent") = objManagementObject.Path.Path
                objDiskDrive("Address") = 0

                For Each objVirtualSystemManagementService As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemManagementService")).Get
                    Dim objParams As ManagementBaseObject = objVirtualSystemManagementService.GetMethodParameters("AddVirtualSystemResources")
                    Dim strResourceSettingData As String() = New String(0) {}
                    strResourceSettingData(0) = objDiskDrive.GetText(TextFormat.CimDtd20)
                    objParams("ResourceSettingData") = strResourceSettingData
                    objParams("TargetSystem") = objComputerSystem.Path.Path
                    Dim objManagementBaseObject As ManagementBaseObject = objVirtualSystemManagementService.InvokeMethod("AddVirtualSystemResources", objParams, Nothing)
                    If objManagementBaseObject("ReturnValue") = 0 Then
                        objSCSIController = objManagementObject
                    End If
                Next
            Next

            Dim objHardDisk As ManagementObject = Nothing
            For Each objResourcePool As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ResourcePool WHERE ResourceType = 21 AND ResourceSubType = 'Microsoft Virtual Hard Disk' AND OtherResourceType = null")).Get
                Dim objAllocationCapabilitiesCollection As ManagementObjectCollection = objResourcePool.GetRelated("Msvm_AllocationCapabilities")
                For Each objAllocationCapabilities As ManagementObject In objAllocationCapabilitiesCollection
                    Dim objSettingsDefineCapabilitiesCollection As ManagementObjectCollection = objAllocationCapabilities.GetRelationships("Msvm_SettingsDefineCapabilities")
                    For Each objSettingsDefineCapabilities As ManagementObject In objSettingsDefineCapabilitiesCollection
                        If objSettingsDefineCapabilities("ValueRole") = 0 Then
                            objHardDisk = New ManagementObject(objSettingsDefineCapabilities("PartComponent").ToString())
                            objHardDisk.Scope = objManagementScope
                        End If
                    Next
                Next
            Next

            Dim objSCSIDrive As ManagementObject = Nothing
            For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ResourceAllocationSettingData WHERE Parent = '" & objSCSIController.Path.Path.Replace("\", "\\") & "' AND Address = '0'")).Get
                objSCSIDrive = objManagementObject
                objHardDisk("Parent") = objSCSIDrive.Path.Path
                objHardDisk("Connection") = New String(0) {strDiskPath}
            Next

            For Each objVirtualSystemManagementService As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemManagementService")).Get
                Dim objParams As ManagementBaseObject = objVirtualSystemManagementService.GetMethodParameters("AddVirtualSystemResources")
                Dim strResourceSettingData As String() = New String(0) {}
                strResourceSettingData(0) = objHardDisk.GetText(TextFormat.CimDtd20)
                objParams("ResourceSettingData") = strResourceSettingData
                objParams("TargetSystem") = objComputerSystem.Path.Path
                Dim objManagementBaseObject As ManagementBaseObject = objVirtualSystemManagementService.InvokeMethod("AddVirtualSystemResources", objParams, Nothing)
            Return JobComplete(objManagementBaseObject, objManagementScope)
            Next
    End Function

    Function SetDVD(ByVal objManagementScope As ManagementScope, ByVal strVMName As String) As Boolean
        Dim objComputerSystem As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ComputerSystem WHERE ElementName = '" & strVMName & "'")).Get
            objComputerSystem = objManagementObject
        Next

        Dim objDVD As ManagementObject = Nothing
        For Each objResourcePool As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ResourcePool WHERE ResourceType=16 and ResourceSubType='Microsoft Synthetic DVD Drive' AND OtherResourceType = null")).Get
            Dim objAllocationCapabilitiesCollection As ManagementObjectCollection = objResourcePool.GetRelated("Msvm_AllocationCapabilities")
            For Each objAllocationCapabilities As ManagementObject In objAllocationCapabilitiesCollection
                Dim objSettingsDefineCapabilitiesCollection As ManagementObjectCollection = objAllocationCapabilities.GetRelationships("Msvm_SettingsDefineCapabilities")
                For Each objSettingsDefineCapabilities As ManagementObject In objSettingsDefineCapabilitiesCollection
                    If objSettingsDefineCapabilities("ValueRole") = 0 Then
                        objDVD = New ManagementObject(objSettingsDefineCapabilities("PartComponent").ToString())
                        objDVD.Scope = objManagementScope
                    End If
                Next
            Next
        Next

        Dim objIDEController As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ResourceAllocationSettingData WHERE ResourceType = 5 AND ResourceSubType = 'Microsoft Emulated IDE Controller' AND Address = '1'")).Get
            objIDEController = objManagementObject
            objDVD("Parent") = objIDEController.Path.Path
            objDVD("Address") = 0
        Next

        For Each objVirtualSystemManagementService As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemManagementService")).Get
            Dim objParams As ManagementBaseObject = objVirtualSystemManagementService.GetMethodParameters("AddVirtualSystemResources")
            Dim strResourceSettingData As String() = New String(0) {}
            strResourceSettingData(0) = objDVD.GetText(TextFormat.CimDtd20)
            objParams("ResourceSettingData") = strResourceSettingData
            objParams("TargetSystem") = objComputerSystem.Path.Path
            Dim objManagementBaseObject As ManagementBaseObject = objVirtualSystemManagementService.InvokeMethod("AddVirtualSystemResources", objParams, Nothing)
            Return JobComplete(objManagementBaseObject, objManagementScope)
        Next
    End Function

    Function MountISO(ByVal objManagementScope As ManagementScope, ByVal strVMName As String, ByVal strIsoPath As String) As Boolean
        Dim objComputerSystem As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ComputerSystem WHERE ElementName = '" & strVMName & "'")).Get
            objComputerSystem = objManagementObject
        Next

        Dim objISO As ManagementObject = Nothing
        For Each objResourcePool As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ResourcePool WHERE ResourceType = 21 AND ResourceSubType = 'Microsoft Virtual CD/DVD Disk' AND OtherResourceType = null")).Get
            Dim objAllocationCapabilitiesCollection As ManagementObjectCollection = objResourcePool.GetRelated("Msvm_AllocationCapabilities")
            For Each objAllocationCapabilities As ManagementObject In objAllocationCapabilitiesCollection
                Dim objSettingsDefineCapabilitiesCollection As ManagementObjectCollection = objAllocationCapabilities.GetRelationships("Msvm_SettingsDefineCapabilities")
                For Each objSettingsDefineCapabilities As ManagementObject In objSettingsDefineCapabilitiesCollection
                    If objSettingsDefineCapabilities("ValueRole") = 0 Then
                        objISO = New ManagementObject(objSettingsDefineCapabilities("PartComponent").ToString())
                        objISO.Scope = objManagementScope
                    End If
                Next
            Next
        Next

        Dim objIDEController As ManagementObject = Nothing
        Dim objDvdDrive As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ResourceAllocationSettingData WHERE ResourceType = 5 AND ResourceSubType = 'Microsoft Emulated IDE Controller' AND Address = '1'")).Get
            objIDEController = objManagementObject
            For Each objManagementObject2 As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ResourceAllocationSettingData WHERE ResourceType = 16  AND ResourceSubType='Microsoft Synthetic DVD Drive' AND Address = '0'")).Get
                objDvdDrive = objManagementObject2
                If objDvdDrive("Parent") = objIDEController.Path.Path Then
                    objISO("Parent") = objDvdDrive.Path.Path
                    objISO("Connection") = New String(0) {strIsoPath}
                End If
            Next
        Next
     
        For Each objVirtualSystemManagementService As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemManagementService")).Get
            Dim objParams As ManagementBaseObject = objVirtualSystemManagementService.GetMethodParameters("AddVirtualSystemResources")
            Dim strResourceSettingData As String() = New String(0) {}
            strResourceSettingData(0) = objISO.GetText(TextFormat.CimDtd20)
            objParams("ResourceSettingData") = strResourceSettingData
            objParams("TargetSystem") = objComputerSystem.Path.Path
            Dim objManagementBaseObject As ManagementBaseObject = objVirtualSystemManagementService.InvokeMethod("AddVirtualSystemResources", objParams, Nothing)
            Return JobComplete(objManagementBaseObject, objManagementScope)
        Next
    End Function

    Function UnMountISO(ByVal objManagementScope As ManagementScope, ByVal strVMName As String) As Boolean
        Dim objComputerSystem As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ComputerSystem WHERE ElementName = '" & strVMName & "'")).Get
            objComputerSystem = objManagementObject
        Next

        Dim objIDEController As ManagementObject = Nothing
        Dim objDvdDrive As ManagementObject = Nothing
        Dim objISO As ManagementObject = Nothing
        For Each objManagementObject As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ResourceAllocationSettingData WHERE ResourceType = 5 AND ResourceSubType = 'Microsoft Emulated IDE Controller' AND Address = '1'")).Get
            objIDEController = objManagementObject
            For Each objManagementObject2 As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ResourceAllocationSettingData WHERE ResourceType = 16  AND ResourceSubType='Microsoft Synthetic DVD Drive' AND Address = '0'")).Get
                objDvdDrive = objManagementObject2
                If objDvdDrive("Parent") = objIDEController.Path.Path Then
                    For Each objManagementObject3 As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_ResourceAllocationSettingData")).Get
                        objISO = objManagementObject3
                        If objISO("Parent") = objDvdDrive.Path.Path Then
                            Exit For
                        End If
                    Next
                End If
            Next
        Next

        For Each objVirtualSystemManagementService As ManagementObject In New ManagementObjectSearcher(objManagementScope, New ObjectQuery("SELECT * FROM Msvm_VirtualSystemManagementService")).Get
            Dim objParams As ManagementBaseObject = objVirtualSystemManagementService.GetMethodParameters("RemoveVirtualSystemResources")
            Dim strResourceSettingData(0) As String
            strResourceSettingData(0) = objISO.Path.Path
            objParams("ResourceSettingData") = strResourceSettingData
            objParams("TargetSystem") = objComputerSystem.Path.Path
            Dim objManagementBaseObject As ManagementBaseObject = objVirtualSystemManagementService.InvokeMethod("RemoveVirtualSystemResources", objParams, Nothing)
            Return JobComplete(objManagementBaseObject, objManagementScope)
        Next
    End Function


    Function JobComplete(ByVal objManagementBaseObject As ManagementBaseObject, ByVal objManagementScope As ManagementScope) As Boolean
        'JobState New = 2  Starting = 3  Running = 4  Suspended = 5  ShuttingDown = 6  Completed = 7  Terminated = 8  Killed = 9  Exception = 10  Service = 11
        If objManagementBaseObject("ReturnValue") <> 0 Then
            Dim strJobPath As String = objManagementBaseObject("Job")
            Dim objJob As New ManagementObject(objManagementScope, New ManagementPath(strJobPath), Nothing)
            objJob.Get()
            Do While objJob("JobState") = 3 Or objJob("JobState") = 4
                System.Threading.Thread.Sleep(1000)
                objJob.Get()
            Loop
            If objJob("JobState") <> 7 Then
                Console.WriteLine("ErrorCode=" & objJob("ErrorCode") & " JobState=" & objJob("JobState"))
                Return False
            Else
                Return True
            End If
        Else
            Return True
        End If
    End Function

End Module
